/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PRODUTOAP                                                */
/* Tabela : PRODUTOAP                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 02/12/2003 Mariana Costa                                                   */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PRODUTOAP
BEFORE INSERT OR UPDATE OR DELETE
ON PRODUTOAP FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPRAP := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATUPRAP := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PRODUTOAP','', 'CDFILIAL='||:OLD.CDFILIAL||';CDPRODUTO='||:OLD.CDPRODUTO||';DTCUSTOAP='||TO_CHAR(:OLD.DTCUSTOAP,'YYYYMMDDHH24MISS')||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PRODUTOAP MODIFY DTULTATUPRAP DEFAULT SYSDATE
/
