/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CAIXA                                                    */
/* Tabela : CAIXA                                                             */
/*                                                                            */
/* Criao:                                                                   */
/* 27/11/2004 - Ronaldo Amaral Costa                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CAIXA
BEFORE INSERT OR UPDATE OR DELETE
ON CAIXA FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCAIX := SYSDATE;
   END IF;

   IF UPDATING THEN
      :NEW.DTULTATUCAIX := SYSDATE;

      IF (NVL(:NEW.NRCONFTELA,0) <> NVL(:OLD.NRCONFTELA,0)) OR (NVL(:NEW.CDFILICONFTE,0) <> NVL(:OLD.CDFILICONFTE,0)) THEN
         UPDATE CONFTELA SET DTULTATUCFTE = SYSDATE
         WHERE  CDFILIAL   = :NEW.CDFILIAL
           AND  NRCONFTELA = :NEW.NRCONFTELA;

         UPDATE ITMENUCONFTE SET DTULTATUITCT = SYSDATE
         WHERE  CDFILIAL   = :NEW.CDFILIAL
           AND  NRCONFTELA = :NEW.NRCONFTELA;
      END IF;

      IF NVL(:NEW.CDGRUPPROD,0) <> NVL(:OLD.CDGRUPPROD,0) THEN
         UPDATE GRUPPROD SET DTULTATUGPPR = SYSDATE
         WHERE  CDGRUPPROD = :NEW.CDGRUPPROD;

         UPDATE PRSUBGRPROD SET DTULTATUPRSUBGR = SYSDATE
         WHERE  CDGRUPPROD = :NEW.CDGRUPPROD;
      END IF;

      IF NVL(:NEW.CDIMPRESSORA,0) <> NVL(:OLD.CDIMPRESSORA,0) THEN
         UPDATE IMPRESSORA SET DTULTATUIMPR = SYSDATE
         WHERE  CDIMPRESSORA = :NEW.CDIMPRESSORA;

         UPDATE IMPRESSOOPER SET DTULTATUIMOP = SYSDATE
         WHERE  CDIMPRESSORA = :NEW.CDIMPRESSORA;
      END IF;


   END IF;

   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CAIXA',:OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDCAIXA='||:OLD.CDCAIXA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CAIXA MODIFY DTULTATUCAIX DEFAULT SYSDATE
/

UPDATE CAIXA SET DTULTATUCAIX = SYSDATE WHERE DTULTATUCAIX IS NULL
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_CAIXA','4.05.131'); END;
/

