/*
 SISTEMA         : COMISSARIA
 DATA DA CRIAO : 01/03/2010
 PROGRAMADOR     : Welbert G. Moitinha
 OBJETIVOS       : Gerao do Menu Breakdown em forma de OPs para o
                   Manufatura.
                   Gerao de requisio para os produtos da companhia
                   Gerao de previso de compras para as materias primas
                   dos servios, sub-grupos e produtos de receita
*/


CREATE OR REPLACE PROCEDURE SERVBREAK_OP(
                                          P_CDFILIAL     IN     ORDPRODUCAO.CDFILIAL    %TYPE,
                                          P_CDPRODUTO    IN     INSUMETAPA .CDPRODINSUMO%TYPE,
                                          P_CDCLASSE     IN     CLASSE     .CDCLASSE    %TYPE,
                                          P_CDCICLO      IN     CICLOCIA   .CDCICLO     %TYPE,
                                          P_DTHRINIPREP  IN     DATE,
                                          P_QTINSUMETAPA IN     INSUMETAPA .QTINSUMETAPA%TYPE,
                                          P_NRSUBORDPROD IN     ORDPRODUCAO.NRSUBORDPROD%TYPE,
                                          P_NRBREAKDOWN  IN     BREAKDOWN  .NRBREAKDOWN %TYPE,
                                          P_CDCIA        IN     COMPANHIA  .CDCIA       %TYPE,
                                          P_QTHISTORICO  IN     INSUMETAPA .QTINSUMETAPA%TYPE,
                                          P_QTSOLICITA   IN     INSUMETAPA .QTINSUMETAPA%TYPE,
                                          P_QTHOLDINGBOX IN     INSUMETAPA .QTINSUMETAPA%TYPE,
                                          P_QTESTPISTA   IN     INSUMETAPA .QTINSUMETAPA%TYPE,
                                          P_QTPREVPROD   IN     INSUMETAPA .QTINSUMETAPA%TYPE,
                                          P_QTPRODUCAO   IN     INSUMETAPA .QTINSUMETAPA%TYPE,
                                          P_CDOPERADOR   IN     OPERADOR   .CDOPERADOR  %TYPE,
                                          P_NRPREVCOMP   IN     PREVCOMP.NRPREVCOMP%TYPE,
                                          P_QTSTANDBY    IN     SERVBREAK.QTSTANDBY%TYPE
                                          ) AS
/*V_NRORDPROD    VARCHAR2(20);*/
   V_NRSUBORDPROD ORDPRODUCAO.NRSUBORDPROD%TYPE;
   V_CDPROCFABRIC PROCFABRICA.CDPROCFABRIC%TYPE;
   V_DTHRINIPREP  DATE;
   V_QTHRPREPARO  NUMBER;
   V_QTHRPREPMAX  NUMBER;
   V_HRINIPRODSER SERVBREAK  .HRINIPRODSER%TYPE;
   V_QTINSUMETAPA INSUMETAPA .QTINSUMETAPA%TYPE;

   V_IDTIPOREC    VARCHAR2(1);
   V_QTRENDREC    RENDPADRAO.QTRENDRECPAD%TYPE;
   V_QTAPROREC    RENDPADRAO.QTAPRORECPAD%TYPE;
   V_IDPRCOMISPRI PRODUTO   .IDPRODCOMISS%TYPE;
   V_CDARVPROD    PRODUTO   .CDARVPROD%TYPE;
   V_NRORDENAOP   VARCHAR2(1);
   V_EXISTEPREV   PREVCOMP.NRPREVCOMP%TYPE;
   V_NRSEQPREVI   ITPREVCOMP.NRITPREVCOMP%TYPE;
   V_CDSETOR      PARAMCOMIS.CDSETORCOMIS%TYPE;
   V_QTCOMPRAS    FLOAT;
   V_QTDEPREVI    FLOAT;
   V_TIPPROPORCAO VARCHAR2(1);
   V_TIPOARREDOND VARCHAR2(1);
   V_QTINSUMO FLOAT;
   V_QTRENDINSU   FLOAT;
   V_QTPADPROCFAB FLOAT;
BEGIN
   V_DTHRINIPREP  := P_DTHRINIPREP;
   V_NRSUBORDPROD := P_NRSUBORDPROD;
   V_NRORDENAOP := V_NRSUBORDPROD;
   V_QTCOMPRAS := 0;
   V_QTDEPREVI := 0;


   SELECT MAX(CDPROCFABRIC)
   INTO V_CDPROCFABRIC
   FROM PROCFABRICA
   WHERE (CDFILIAL     = P_CDFILIAL ) AND
         (CDPRODUTO    = P_CDPRODUTO) AND
         (IDPROFABPADR = 'S'        );

   IF V_CDPROCFABRIC IS NULL THEN

        SELECT CDARVPROD
        INTO V_CDARVPROD
        FROM PRODUTO
        WHERE CDPRODUTO = P_CDPRODUTO;

   	IF V_NRSUBORDPROD = '0' THEN
   	   raise_application_error(-20502,'n_proc_ser'||V_CDARVPROD ||'*',false);
   	ELSIF V_NRSUBORDPROD = '1' THEN
   	   raise_application_error(-20502,'n_proc_sbg'||V_CDARVPROD ||'*',false);
   	ELSIF V_NRSUBORDPROD = '2' THEN
   	   raise_application_error(-20502,'n_proc_rec'||V_CDARVPROD ||'*',false);
   	ELSE
   	   raise_application_error(-20502,'n_proc_pro'||V_CDARVPROD ||'*',false);
      END IF;
   END IF;

   FOR C_INSUMO IN (SELECT IE.CDPRODINSUMO,IE.QTINSUMETAPA,PR.IDPRODCOMISS
                    FROM INSUMETAPA IE, PRODUTO PR
                    WHERE (IE.CDFILIAL     = P_CDFILIAL     ) AND
                          (IE.CDPRODUTO    = P_CDPRODUTO    ) AND
                          (IE.CDPROCFABRIC = V_CDPROCFABRIC ) AND
                          (PR.CDPRODUTO    = IE.CDPRODINSUMO) AND
                          (PR.IDPRODCOMISS   IS NOT NULL    )) LOOP

      V_QTRENDREC := 1;
      IF C_INSUMO.IDPRODCOMISS = '2' THEN
      /*   V_NRSUBORDPROD := '1';*/
         SELECT NVL(SUM(QTHRPREPSUB),0)
         INTO V_QTHRPREPARO
         FROM TEMPOPREPSUB
         WHERE (CDFILIAL  = P_CDFILIAL           ) AND
               (CDSERVICO = P_CDPRODUTO          ) AND
               (CDSUBGRU  = C_INSUMO.CDPRODINSUMO);
      ELSIF C_INSUMO.IDPRODCOMISS = '3' THEN
      /*   V_NRSUBORDPROD := '2'; */
         SELECT NVL(SUM(QTHRPREPREC),0)
         INTO V_QTHRPREPARO
         FROM TEMPOPREPREC
         WHERE (CDFILIAL  = P_CDFILIAL           ) AND
               (CDRECEITA = C_INSUMO.CDPRODINSUMO);

         /* Verifica se  uma sub-receita */
         SELECT IDPRODCOMISS
         INTO V_IDPRCOMISPRI
         FROM PRODUTO
         WHERE (CDPRODUTO = P_CDPRODUTO);
         IF V_IDPRCOMISPRI = '3' THEN
            RETORNA_RENDREC(P_CDFILIAL,P_CDPRODUTO,V_IDTIPOREC,
                            V_QTRENDREC,V_QTAPROREC);
         END IF;
      END IF;

      V_QTINSUMETAPA := P_QTINSUMETAPA*C_INSUMO.QTINSUMETAPA/V_QTRENDREC;

      SELECT NVL(SUM(TE.QTHRETFABRPR),0)+V_QTHRPREPARO
      INTO V_QTHRPREPARO
      FROM TEMPOETAFABR TE, PROCFABRICA PF
      WHERE (PF.CDFILIAL     = P_CDFILIAL           ) AND
            (PF.CDPRODUTO    = C_INSUMO.CDPRODINSUMO) AND
            (PF.IDPROFABPADR = 'S'                  ) AND
            (TE.CDFILIAL     = PF.CDFILIAL          ) AND
            (TE.CDPRODUTO    = PF.CDPRODUTO         ) AND
            (TE.CDPROCFABRIC = PF.CDPROCFABRIC      ) AND
            (V_QTINSUMETAPA BETWEEN TE.VRINIQTFABPR AND TE.VRFINQTFABPR);
/* Verifica se o produto  semi-acabado*/
      V_NRORDENAOP := V_NRORDENAOP + 1;

      IF V_QTINSUMETAPA = 0 THEN
   	   raise_application_error(-20502,'FUNCIONA BENCAO'||'*'||P_CDPRODUTO||'BENCAO',false);
      END IF;

      SERVBREAK_OP(P_CDFILIAL, C_INSUMO.CDPRODINSUMO, P_CDCLASSE, P_CDCICLO,
                   V_DTHRINIPREP, V_QTINSUMETAPA, V_NRORDENAOP,
                   P_NRBREAKDOWN, P_CDCIA, P_QTHISTORICO, P_QTSOLICITA,
                   P_QTHOLDINGBOX, P_QTESTPISTA, P_QTPREVPROD, P_QTPRODUCAO,
                   P_CDOPERADOR, P_NRPREVCOMP, P_QTSTANDBY);

--raise_application_error(-20502,V_QTHRPREPARO,false);
      IF V_QTHRPREPMAX < V_QTHRPREPARO THEN
         V_DTHRINIPREP := V_DTHRINIPREP+(V_QTHRPREPARO-V_QTHRPREPMAX);
         V_QTHRPREPMAX := V_QTHRPREPARO;
      END IF;
   END LOOP;

   SELECT MIN(SB.HRINIPRODSER)
   INTO V_HRINIPRODSER
   FROM SERVBREAK SB, TURNO_PRODUCAO TP
   WHERE (SB.CDFILIAL    = P_CDFILIAL   ) AND
         (SB.NRBREAKDOWN = P_NRBREAKDOWN) AND
         (SB.CDSERVICO   = P_CDPRODUTO  ) AND
         (TRUNC(SB.DTHRSERBREAK) = TRUNC(V_DTHRINIPREP)) AND
         (SB.HRINIPRODSER BETWEEN TP.HRINIDECOL AND TP.HRFINDECOL) AND
         (TO_CHAR(V_DTHRINIPREP,'HH24MI') BETWEEN TP.HRINIDECOL AND TP.HRFINDECOL);

   IF V_HRINIPRODSER IS NOT NULL THEN
      IF V_HRINIPRODSER < ((V_DTHRINIPREP-TRUNC(V_DTHRINIPREP))*24) THEN
         V_DTHRINIPREP := TRUNC(V_DTHRINIPREP)+(V_HRINIPRODSER/24);
      END IF;
      IF V_HRINIPRODSER < TO_CHAR(V_DTHRINIPREP,'HH24MI') THEN
         V_DTHRINIPREP := TO_DATE(TO_CHAR(V_DTHRINIPREP,'DDMMYYYY')||V_HRINIPRODSER,'DDMMYYYYHH24MI');
      END IF;

      UPDATE SERVBREAK
      SET QTSERVPROD   = QTSERVPROD + P_QTINSUMETAPA,
          HRINIPRODSER = (V_DTHRINIPREP-TRUNC(V_DTHRINIPREP))*24
      WHERE (CDFILIAL    = P_CDFILIAL   ) AND
            (NRBREAKDOWN = P_NRBREAKDOWN) AND
            (CDSERVICO   = P_CDPRODUTO  );
   ELSE

      V_HRINIPRODSER := TO_CHAR(V_DTHRINIPREP,'HH24MI');

      INSERT INTO SERVBREAK
      (CDFILIAL,NRBREAKDOWN,CDCIA,CDSERVICO,CDCLASSE,CDCICLO,HRINIPRODSER,DTHRSERBREAK,
       NRORDPROD,NRSUBORDPROD,QTHISTORICO,QTSOLICITA,QTHOLDINGBOX,QTESTPISTA,
       QTPREVPROD,QTSERVPROD,QTPRODUCAO,IDLOCALEST,DSMOVEST,CDOPERADOR, QTSTANDBY)
      VALUES
      (P_CDFILIAL,P_NRBREAKDOWN,P_CDCIA,P_CDPRODUTO,P_CDCLASSE,P_CDCICLO,V_HRINIPRODSER,V_DTHRINIPREP,
       NULL,V_NRSUBORDPROD, P_QTHISTORICO,P_QTSOLICITA,P_QTHOLDINGBOX,P_QTESTPISTA,
       P_QTPREVPROD,P_QTINSUMETAPA,P_QTPRODUCAO,'1','Gerao automtica do Breakdown',P_CDOPERADOR, P_QTSTANDBY);
   END IF;

   FOR C_MATEPRIMA IN (SELECT
                          INS.CDPRODINSUMO,
                          SUM(QTPREVI_MATPRIMA(P_CDFILIAL, P_CDPRODUTO, INS.CDPROCFABRIC, INS.CDETAPAPROD, INS.CDPRODINSUMO, P_QTINSUMETAPA)) AS QTMATEPRIMA
                       FROM
                          PROCFABRICA PF,
                          INSUMETAPA INS
                       WHERE
                          (PF.CDFILIAL      = P_CDFILIAL)       AND
                          (PF.CDPRODUTO     = P_CDPRODUTO)   AND
                          (PF.IDPROFABPADR  = 'S')              AND
                          (INS.CDFILIAL     = PF.CDFILIAL)      AND
                          (INS.CDPRODUTO    = PF.CDPRODUTO)     AND
                          (INS.CDPROCFABRIC = PF.CDPROCFABRIC)  AND
                          (NVL(INS.IDSEMIACETAP,'N') <> 'S')
                       GROUP BY
                          INS.CDPRODINSUMO
                       ORDER BY
                          INS.CDPRODINSUMO
                      ) LOOP

         BEGIN
            SELECT
               NRPREVCOMP
            INTO
               V_EXISTEPREV
            FROM
               PREVCOMP
            WHERE
               CDFILIAL = P_CDFILIAL AND
               NRPREVCOMP = P_NRPREVCOMP;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_EXISTEPREV := '';
         END;

         IF V_EXISTEPREV IS NULL THEN
            BEGIN
               SELECT CDSETORCOMIS
               INTO V_CDSETOR
               FROM PARAMCOMIS
               WHERE CDFILIAL = P_CDFILIAL;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                   V_CDSETOR := '';
                END;

            INSERT INTO PREVCOMP
                  (CDFILIAL, NRPREVCOMP, CDSETOR, CDOPGERPRCOM, DTHRPREVCOMP, IDSTPREVCOMP)
               VALUES
                  (P_CDFILIAL, P_NRPREVCOMP, V_CDSETOR , P_CDOPERADOR, SYSDATE, 'P');
         END IF;

         BEGIN
            SELECT
               NRITPREVCOMP , QTPREVCOMP
            INTO V_NRSEQPREVI, V_QTCOMPRAS
            FROM ITPREVCOMP
            WHERE
               CDFILIAL  = P_CDFILIAL AND
               NRPREVCOMP = P_NRPREVCOMP AND
               CDPRODUTO = C_MATEPRIMA.CDPRODINSUMO AND
               DTENTPRECOMP = V_DTHRINIPREP;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_NRSEQPREVI := '';
         END;

         IF V_NRSEQPREVI IS NOT NULL THEN
            UPDATE ITPREVCOMP
            SET  QTPREVCOMP = QTPREVCOMP + NVL(V_QTCOMPRAS,0)
            WHERE
               CDFILIAL  = P_CDFILIAL AND
               NRPREVCOMP = P_NRPREVCOMP AND
               NRITPREVCOMP = V_NRSEQPREVI;
         ELSE
            SELECT
               NVL(MAX(NRITPREVCOMP), 0) + 1 AS NRITPREVCOMP
            INTO
               V_NRSEQPREVI
            FROM
               ITPREVCOMP
            WHERE
               CDFILIAL   = P_CDFILIAL    AND
               NRPREVCOMP = P_NRPREVCOMP;

            INSERT INTO ITPREVCOMP
               (CDFILIAL, NRPREVCOMP, NRITPREVCOMP, CDPRODUTO, DTENTPRECOMP, QTPREVCOMP)
            VALUES
               (P_CDFILIAL, P_NRPREVCOMP, LPAD(TO_CHAR(V_NRSEQPREVI), 4, '0'), C_MATEPRIMA.CDPRODINSUMO,
                V_DTHRINIPREP, NVL(C_MATEPRIMA.QTMATEPRIMA, 0));
         END IF;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('SERVBREAK_OP','0.00.000'); END;
/


